/*
Hibernus++ for MSP430FR5739:

Hibernus++: Software-based approach to hibernate and restore adaptively the system's state
in response to a power failure. This software exploits an external comparator.

Citation: If you are using this code for your research please cite:

[1]	D. Balsamo, A. S. Weddell, G. V. Merrett, B. M. Al-Hashimi, D. Brunelli and L. Benini,
"Hibernus: Sustaining Computation During Intermittent Supply for Energy-Harvesting Systems,"
in IEEE Embedded Systems Letters, vol. 7, no. 1, pp. 15-18, March 2015.

[2]	D. Balsamo; A. Weddell; A. Das; A. Arreola; D. Brunelli; B. Al-Hashimi; G. Merrett; L. Benini,
"Hibernus++: A Self-Calibrating and Adaptive System for Transiently-Powered Embedded Devices,"
in IEEE Transactions on Computer-Aided Design of Integrated Circuits and Systems. 

This research has been supported by the University of Southampton and the University of Bologna.
Copyright 2018, Domenico Balsamo, All rights reserved.
06/02/2019
*/

#include <msp430.h> 

/*
 * main.c
 */

#pragma SET_DATA_SECTION(".fram_vars")
unsigned int CC_check;

extern unsigned long int *FRAM_write_ptr;

//This pointer is used to copy the RAM
extern unsigned long int *RAM_copy_ptr; // define a pointer for memory copy

int counter=0;

//These pointers and variable are used to set the PC
extern unsigned long int *FRAM_pc;
extern unsigned long int* current_SP;
#pragma SET_DATA_SECTION()

unsigned int count=0;
unsigned int l=0;

#define CC 0xEFF6

long int j;

volatile static int ErrorCount=0; // Note. static used for easier debugging

long int g=0;

 int main(void) {

	WDTCTL = WDTPW | WDTHOLD;	// Stop watchdog timer

	P3DIR |= BIT2;
	P3OUT |= BIT2; // LED  ON

    P1OUT &= ~(BIT4);
    P1DIR |= BIT4;

    //MCU ON

    //Restore Function

    volatile int i=0;

    SystemInit();


    while(1){


    	P2DIR |= BIT6;
    	P2OUT |= BIT6; // LED  ON
		
		//Write your main 


    	//Main() is completed

    	P2OUT &= ~(BIT6); // LED  OFF

       j=0;

  	   while(j<1000){
  	     	j++;
  	     }



    }


}


